/*******************************************************************************
 * (c) Copyright 2012 Microsemi Corporation.  All rights reserved.
 *
 *  Microsemi Smartfusion2 USB device core interface driver layer Implementation.	
 *  
 *
 *  Header file for mss_usb_core.c
 *
 * SVN $Revision: 4841 $
 * SVN $Date: 2012-12-17 10:34:38 +0530 (Mon, 17 Dec 2012) $
 */

#ifndef __MSS_USB_DEVICE_CIF_H_
#define __MSS_USB_DEVICE_CIF_H_

#include "../../CMSIS/m2sxxx.h"

#ifdef __cplusplus
extern "C" {
#endif 

/*******************************************************************************
 * Exported APIs from Device Core Interface Later.
   USB Class driver implementation is allowed to use these APIs.
 */

/* DeviceInfo register related APIs */
/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
mss_usb_core_info_t
MSS_USB_core_get_device_info
(
	void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  

  @return
  
  Example:
  @code
  @endcode
*/

void
MSS_USB_core_device_set_address
(
	uint8_t addr
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
uint8_t
MSS_USB_core_device_get_address
(
	void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_force_resume
(
	void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void 
MSS_USB_core_device_set_isoupdate
(
    void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/

void 
MSS_USB_core_device_clr_isoupdate
(
    void
);

/*******************************************************************************
 * Exported APIs from Device Core Interface Later. For USB Device Core Driver oly.
   These APIs are not allowed to be used by USB Class driver implementation
 */

 /***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void 
MSS_USB_core_rx_ep_clr_stall
(
	mss_usb_ep_num_t ep_num
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_cep_stall
(
	void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_tx_ep_stall
(
	mss_usb_ep_num_t ep_num
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_rx_ep_stall
(
	mss_usb_ep_num_t ep_num
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void 
MSS_USB_core_cep_clr_stall
(
	void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void 
MSS_USB_core_tx_ep_clr_stall
(
	mss_usb_ep_num_t ep_num
);

 /***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_init
(
	mss_usb_device_speed_t speed
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_connect
(
	void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_disconnect
(
	void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_cep_configure
(
	void
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_cep_rx_prepare
(
	mss_usb_ep_t* device_ep
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_cep_read_pkt
(
	mss_usb_ep_t* device_ep
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_cep_write_pkt
(
	mss_usb_ep_t* device_ep
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_tx_ep_configure
(
	mss_usb_ep_t* device_ep
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_rx_ep_configure
(
	mss_usb_ep_t* device_ep
);

/***************************************************************************//**
  @brief
  
  @param 
  
  @param 
  
  @return
  

  Example:
  @code
  @endcode
*/
void
MSS_USB_core_device_rx_ep_read_prepare
(
	mss_usb_ep_t* device_ep
);


#ifdef __cplusplus
}
#endif

#endif  /* __MSS_USB_DEVICE_CIF_H_ */
