/*******************************************************************************
 * (c) Copyright 2012 Microsemi Corporation.  All rights reserved.
 *
 *  Microsemi Smartfusion2 USB device core interface driver Implementation.	
 *  
 *
 *  This file provides interfaces to perform register and register bit level 
 *  read / write operations.  
 * 
 *
 * SVN $Revision: 4841 $
 * SVN $Date: 2012-12-17 10:34:38 +0530 (Mon, 17 Dec 2012) $
 */

#ifndef __MSS_USB_DEVICE_REG_IO_H_
#define __MSS_USB_DEVICE_REG_IO_H_

#ifdef __cplusplus
extern "C" {
#endif 

#include "../../CMSIS/m2sxxx.h"
#include "mss_usb_core_regs.h"

   
/*******************************************************************************
* Device mode functions
*/

/*******************************************************************************
 * POWER register related APIs
 */

static __INLINE uint8_t 
MSS_USB_core_device_is_suspend_mode
(
	void
)
{
	return( ( ( USB->POWER & POWER_REG_SUSPEND_MODE_MASK ) ? MSS_USB_BOOLEAN_TRUE : MSS_USB_BOOLEAN_FALSE ) );
}

/*To force out of the Suspend while in Device mode.*/
static __INLINE void 
MSS_USB_core_device_resume_gen
(
	void
)
{
    USB->POWER |= POWER_REG_RESUME_SIGNAL_MASK;
    /*clear after 10ms*/
}

/*******************************************************************************
 * DEVCTL register related APIs
 */
static __INLINE uint8_t
MSS_USB_device_is_session_on
(
	void
)
{
	return ( ( ( USB->DEV_CTRL & DEV_CTRL_SESSION_MASK ) ? MSS_USB_BOOLEAN_TRUE : MSS_USB_BOOLEAN_FALSE ) );
}

static __INLINE void
MSS_USB_device_initiate_srp
(
	void
)
{
	/*TODO:make sure that the device is suspended and is a Bdevice when this function is called*/
	USB->DEV_CTRL |= DEV_CTRL_SESSION_MASK;
}

static __INLINE void
MSS_USB_device_initiate_hnp
(
	void
)
{
	/*TODO:make sure that the device is Bdevice when this function is called*/
	USB->DEV_CTRL |= DEV_CTRL_HOST_REQ_MASK;
}

#ifdef __cplusplus
}
#endif

#endif  /* __MSS_USB_DEVICE_REG_IO_H_ */
