//////////////////////////////////////////////////////////////////////
// Created by Actel SmartDesign Mon Apr 22 17:41:51 2013
// Testbench Template
// This is a basic testbench that instantiates your design with basic 
// clock and reset pins connected.  If your design has special
// clock/reset or testbench driver requirements then you should 
// copy this file and modify it. 
//////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps

module testbench;

parameter SYSCLK_PERIOD = 100; // 10MHz

reg SYSCLK;
reg NSYSRESET;

initial
begin
    SYSCLK = 1'b0;
    NSYSRESET = 1'b0;
end

//////////////////////////////////////////////////////////////////////
// Reset Pulse
//////////////////////////////////////////////////////////////////////
initial
begin
    #(SYSCLK_PERIOD * 10 )
        NSYSRESET = 1'b1;
end


//////////////////////////////////////////////////////////////////////
// 10MHz Clock Driver
//////////////////////////////////////////////////////////////////////
always @(SYSCLK)
    #(SYSCLK_PERIOD / 2.0) SYSCLK <= !SYSCLK;


//////////////////////////////////////////////////////////////////////
// Instantiate Unit Under Test:  g4m_system_top
//////////////////////////////////////////////////////////////////////
g4m_system_top g4m_system_top_0 (
    // Inputs
    .DEVRST_N(NSYSRESET),
    .MAC_MII_RX_ER({1{1'b0}}),
    .MAC_MII_RX_DV({1{1'b0}}),
    .MAC_MII_CRS({1{1'b0}}),
    .MAC_MII_COL({1{1'b0}}),
    .MAC_MII_RX_CLK(SYSCLK),
    .MAC_MII_TX_CLK(SYSCLK),
    .XTL(SYSCLK),
    .SPI_1_DI({1{1'b0}}),
    .MMUART_1_RXD({1{1'b0}}),
    .MMUART_0_RXD({1{1'b0}}),
    .USB_ULPI_DIR({1{1'b0}}),
    .USB_ULPI_NXT({1{1'b0}}),
    .SPI_0_DI({1{1'b0}}),
    .MDDR_DQS_TMATCH_0_IN(NSYSRESET),
    .MAC_MII_RXD({4{1'b0}}),

    // Outputs
    .GPIO_0_OUT( ),
    .GPO_2( ),
    .GPIO_1( ),
    .MMUART_0_TXD( ),
    .USER_FAB_RESET_N( ),
    .MAC_MII_TX_EN( ),
    .MAC_MII_TX_ER( ),
    .MAC_MII_MDC( ),
    .MDDR_CAS_N( ),
    .MDDR_CLK( ),
    .MDDR_CLK_N( ),
    .MDDR_CKE( ),
    .MDDR_CS_N( ),
    .MDDR_ODT( ),
    .MDDR_RAS_N( ),
    .MDDR_RESET_N( ),
    .MDDR_WE_N( ),
    .SPI_1_DO( ),
    .MMUART_1_TXD( ),
    .USB_ULPI_STP( ),
    .ULPI_RST( ),
    .SPI_0_DO( ),
    .EXT_RESET_OUT_N( ),
    .MDDR_DQS_TMATCH_0_OUT( ),
    .MAC_MII_TXD( ),
    .MDDR_ADDR( ),
    .MDDR_BA( ),

    // Inouts
    .MAC_MII_MDIO( ),
    .SPI_1_CLK( ),
    .SPI_1_SS0( ),
    .SPI_0_CLK( ),
    .SPI_0_SS0( ),
    .USB_ULPI_XCLK( ),
    .I2C_0_SDA( ),
    .I2C_0_SCL( ),
    .I2C_1_SDA( ),
    .I2C_1_SCL( ),
    .USB_ULPI_DATA( ),
    .MDDR_DM_RDQS( ),
    .MDDR_DQ( ),
    .MDDR_DQS( )

);

endmodule

